<template>
  <header class="shadow sticky top-0 z-50 transition duration-500 ease-in-out" :class="{ 'bg-black bg-opacity-100': isScrolled, 'bg-white bg-opacity-5': !isScrolled }">
    <div class="container mx-auto max-w-screen-xl lg:max-w-screen-lg lg:px-5 px-4 py-4 flex justify-between items-center">
      <!-- Logo -->
      <a href="/" class="text-xl font-bold text-gray-800 w-2/6 sm:w-1/6 lg:w-1/6 pr-4">
        <img src="/images/logo.svg">
      </a>

      <!-- Search bar -->
      <form action="#" method="GET" class="hidden sm:block flex w-4/6 lg:w-3/6 rounded relative transition duration-500 ease-in-out" :class="{ 'bg-white bg-opacity-5': isScrolled, 'bg-black bg-opacity-13': !isScrolled }">
        <img src="/images/material/ico-movie.svg" alt="" class="absolute p-3">
        <input type="text" name="search" v-model="searchText" @keyup="search" placeholder="Search" class="text-white pl-12 pr-4 py-3 bg-transparent w-full focus:border-none focus:outline-none" />
        <button type="submit" class="px-4 text-white bg-transparent hover:bg-gray-700 absolute right-0 top-4">
          <img src="/images/material/ico-search.svg">
        </button>
        <ul v-if="showSuggestions" class="bg-black bg-opacity-90 rounded-b-2xl px-4 md:px-6 py-6 md:py-8 absolute top-full left-0 right-0 z-12">
          <li v-for="movie in suggestedMovies" :key="movie.id" class="cursor-pointer font-semibold text-sm text-gray-300 mb-2 last:mb-0">
            <router-link :to="{ name: 'movies-detail', params: { id: movie.id } }" @click="selectSuggestion(movie.title)">
              {{ movie.title }}
            </router-link>
          </li>
        </ul>
      </form>

      <!-- Menu Categories -->
      <div class="hidden lg:block w-7/12 lg:w-7/12">
        <ul class="flex justify-between items-center text-white-600">
          <li class="ml-10 relative dropdown  lg:ml-5">
            <a class="dropdown-toggle cursor-pointer text-sm font-semibold text-white uppercase hover:text-opacity-50">
              <i class="fas fa-film mr-2"></i>
              Categories
            </a>
            <div class="dropdown-menu absolute hidden text-gray-700 pt-1">
              <div class="flex flex-col items-start bg-white border rounded py-3 px-4 shadow-md">
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Action
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Adventure
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Animation
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Comedy
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Crime
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Documentary
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Drama
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Family
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Fantasy
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  History
                </a>
                <a href="#" class="text-xs uppercase hover:text-gray-800 py-1">
                  Horror
                </a>
              </div>
            </div>
          </li>
          <li class="ml-10 relative  lg:ml-5">
            <router-link :to="{ name: 'movies' }" class="text-sm font-semibold text-white uppercase hover:text-opacity-50">
              <i class="fas fa-film mr-2"></i>
              Movies
            </router-link>
          </li>
          <li class="ml-10 relative  lg:ml-5">
            <a href="#" class="text-sm font-semibold text-white uppercase hover:text-opacity-50">
              <i class="fas fa-tv mr-2"></i>
              TV Shows
            </a>
          </li>
          <li class="ml-10  lg:ml-5">
            <a href="#" class="text-sm font-semibold text-white uppercase hover:text-opacity-50">
              <i class="fas fa-user mr-2"></i>
              Login
            </a>
          </li>
        </ul>
      </div>

      <!-- Responsive Menu Categories -->
      <div class="lg:hidden">
        <button type="button" class="block text-gray-600 hover:text-gray-800 focus:text-gray-800 focus:outline-none">
          <img src="/images/material/ico-menu.svg" alt="" class="w-12 -mt-1 h-auto">
        </button>

        <div class="hidden absolute top-0 left-0 w-full bg-white z-50">
          <ul class="flex flex-col items-center py-2">
          
            <li class="mb-2">
              <a href="#" class="hover:text-gray-800">
                <i class="fas fa-film mr-2"></i>
                Movies
              </a>
            </li>
            <li class="mb-2">
              <a href="#" class="hover:text-gray-800">
                <i class="fas fa-tv mr-2"></i>
                TV Shows
              </a>
            </li>
            <li>
              <a href="#" class="hover:text-gray-800">
                <i class="fas fa-user mr-2"></i>
                Login
              </a>
            </li>
          </ul>
        </div>
      </div>
    </div>
  </header>
</template>
<script>
  export default {
    data() {
      return {
        isScrolled: false,
        searchText: '',
        showSuggestions: false,
        suggestion: [],
        movie: [
          { 
            id: 1,
            title: "Wonder Woman 1984",
            image: "/images/content/image-4.jpg",
            genre: "Fantasy, Action, Adventure",
            rating: "7.0",
            year: 2020 
          },
          { 
            id: 2,
            title: "Below Zero",
            image: "/images/content/image-5.jpg",
            rating: "6.4",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 3,
            title: "The Little Things",
            image: "/images/content/image-6.jpg",
            rating: "6.3",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 4,
            title: "Outside the Wire",
            image: "/images/content/image-7.jpg",
            rating: "6.5",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 5,
            title: "Black Water: Abyss",
            image: "/images/content/image-8.jpg",
            rating: "5.1",
            genre: "Fantasy, Action, Adventure",
            year: 2020 
          },
          { 
            id: 6,
            title: "Breach",
            image: "/images/content/image-9.jpg",
            rating: "4.6",
            genre: "Fantasy, Action, Adventure",
            year: 2021 
          },
          { 
            id: 7,
            title: "Soul",
            image: "/images/content/image-10.jpg",
            rating: "8.3",
            genre: "Fantasy, Action, Adventure",
            year: 2020 
          },
          { 
            id: 8,
            title: "Fast & Furious Present 8",
            image: "/images/content/image-11.jpg",
            rating: "6.9",
            genre: "Fantasy, Action, Adventure",
            year: 2017 
          },
          { 
            id: 9,
            title: "The Croods: A New Age",
            image: "/images/content/image-12.jpg",
            rating: "7.6",
            genre: "Fantasy, Action, Adventure",
            year: 2020
          },
          { 
            id: 10,
            title: "Vanguard",
            image: "/images/content/image-13.jpg",
            rating: "6.3",
            genre: "Fantasy, Action, Adventure",
            year: 2020
          }
        ]
      };
    },
    computed: {
      suggestedMovies() {
        return this.movie.filter(movies => {
          return movies.title.toLowerCase().includes(this.searchText.toLowerCase());
        });
      },
    },
    mounted() {
      window.addEventListener('scroll', this.handleScroll);
      window.addEventListener("click", this.hideSuggestions);
    },
    beforeDestroy() {
      window.removeEventListener("click", this.hideSuggestions);
    },
    destroyed() {
      window.removeEventListener('scroll', this.handleScroll);
    },
    methods: {
      handleScroll() {
        this.isScrolled = window.scrollY > 0;
      },
      search() {
        if (this.searchText.length > 0) {
          // Perform an API request or local search for suggestions
          // and update the `suggestions` property
          this.showSuggestions = true;
        } else {
          this.showSuggestions = false;
        }
      },
      selectSuggestion(movies) {
        this.searchText = movies;
        this.showSuggestions = false;
      },
      hideSuggestions() {
        this.showSuggestions = false;
      },
      // searchMovie(id) {
      //   const id = event.target.dataset.id;
      //   this.$router.push({ name: 'movies-detail', params: { id } })
      // }
    },
  }
  window.onload = function() {
    const dropdownToggles = document.querySelectorAll('.dropdown-toggle');

    // Add click event listener to each toggle
    dropdownToggles.forEach((toggle) => {
      toggle.addEventListener('click', (event) => {
        event.preventDefault();
        
        // Find the parent .dropdown div
        const parent = event.target.closest('.dropdown');

        // Find the dropdown-menu
        const menu = parent.querySelector('.dropdown-menu');

        // Toggle the visibility of the dropdown-menu
        menu.classList.toggle('hidden');

        // Add click event listener to the document object
        document.addEventListener('click', (event) => {
          // Check if the target of the click event is inside the menu
          if (!toggle.contains(event.target)) {
            // Hide the menu
            menu.classList.add('hidden');
          }
        });
      });
    });
  };
</script>